# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .account_type import AccountType
from .app_schemas_assets_public_access_level import AppSchemasAssetsPublicAccessLevel
from .asset_type import AssetType
from .context_label_schema import ContextLabelSchema
from .data_class_item import DataClassItem


class DataAssetRow(pydantic.BaseModel):
    id: str
    data_store_id: str
    name: str
    type: AssetType
    size: int
    data_element_count: typing.Optional[int]
    sensitivity_score: typing.Optional[float]
    sensitivity_level: typing.Optional[int]
    retention: typing.Optional[int]
    object_count: typing.Optional[int]
    row_count: typing.Optional[int]
    public_access_level: typing.Optional[AppSchemasAssetsPublicAccessLevel]
    is_backed_up: typing.Optional[bool]
    findings_count: typing.Optional[int]
    connector_name: str = pydantic.Field(alias="Connector__name")
    connector_account_id: str = pydantic.Field(alias="Connector__account_id")
    data_store_name: str = pydantic.Field(alias="DataStore__name")
    data_store_region: typing.Optional[str] = pydantic.Field(alias="DataStore__region")
    database_engine: typing.Optional[str] = pydantic.Field(alias="Database__engine")
    connector_account_type: AccountType = pydantic.Field(alias="Connector__account_type")
    data_classes: typing.Optional[typing.List[DataClassItem]]
    context_labels: typing.Optional[typing.List[ContextLabelSchema]]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
