# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .access_permissions import AccessPermissions
from .data_class_item import DataClassItem
from .identity_origin import IdentityOrigin
from .provider_minimal_metadata import ProviderMinimalMetadata


class RoleIdentity(pydantic.BaseModel):
    id: str
    name: str
    origin: IdentityOrigin
    provider: ProviderMinimalMetadata
    permissions: typing.List[AccessPermissions]
    last_activity: typing.Optional[str]
    data_classes: typing.Optional[typing.List[DataClassItem]]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
